using System;
using System.Threading;
using Styx;
using Styx.Common;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.CommonBot;
using Styx.Common.Helpers;

namespace DYDH
{
    public class DYDH : HBPlugin
    {

        //Configuration
        public int HealAtPercentageWhenNoCombat = 65; //The percentage at we are going to heal out of combat
        public int HealAtPercentage = 40; //The percentage at we are going to heal.
        public int Spell = 774; //The spell that is going to be cast.
        public bool HealWhenMounted = true; //If you are mounted, do you want to heal?
        public bool DebugMode = false; //Used for debugging... Not needed for the public.



        public override string Name { get { return "Darn You Druid Heal!"; } }
        public override string Author { get { return "Thunderofnl"; } }
        public override Version Version { get { return new Version(1, 1, 0, 0); } }
        public static LocalPlayer Me = StyxWoW.Me;
        private readonly WaitTimer _updateTimer = WaitTimer.OneSecond;

        public DYDH()
        {
            Logging.Write("Darn You Druid Heal! - Loaded");

        }

        public override void Pulse()
        {
            if (_updateTimer.IsFinished)
            {
                _updateTimer.Reset();
                if (DebugMode)
                {
                    Logging.Write("Debug: " + Convert.ToInt32(Me.HealthPercent));
                    Logging.Write("Debug: " + Convert.ToInt32(Me.Specialization));
                }

                if (!Me.IsDead)
                {
                    if (!Me.Mounted || HealWhenMounted)
                    {
                        int Healthpercentage = Convert.ToInt32(Me.HealthPercent);
                        if (Me.Class.ToString() == "Druid")
                        {
                            if (!Me.IsActuallyInCombat)
                            {
                                if (Healthpercentage <= HealAtPercentageWhenNoCombat)
                                {
                                    SpellManager.Cast(Spell);
                                }
                            }
                            if (Healthpercentage <= HealAtPercentage)
                            {

                                SpellManager.Cast(Spell);
                                 Thread.Sleep(6000);
                            }
                        }
                        else
                        {
                            _updateTimer.Stop();
                        }
                    }
                }
            }
        }

    }
}